#ifndef __AtomicPropositions_h__
#define __AtomicPropositions_h__

#include "String.h"
#include "UniqueVector.h"

class AtomicPropositions
{
public:
    void add( const String &proposition )
    {
        _propositions.append( proposition );
    }

    void add( AtomicPropositions &other )
    {
        for ( unsigned i = 0; i < other.size(); ++i )
        {
            add( other.at( i ) );
        }
    }

    String at( unsigned index )
    {
        return _propositions[index];
    }

    Vector<String> get() const
    {
        return _propositions;
    }

    unsigned size() const
    {
        return _propositions.size();
    }

    String toString()
    {
        String output;

        if ( _propositions.empty() )
        {
            return "Phi";
        }

        Vector<String> copy = _propositions;
        copy.sort();

        for ( unsigned i = 0; i < copy.size() - 1; ++i )
        {
            output += copy[i] + ";";
        }
        output += copy.last();

        return output;
    }

    void clear()
    {
        _propositions.clear();
    }

private:
    UniqueVector<String> _propositions;
};

#endif // __AtomicPropositions_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
