#ifndef __EventVector_h__
#define __EventVector_h__

#include "Event.h"
#include "Vector.h"

class EventVector : public UniqueVector<Event>
{
public:
    bool operator==( const EventVector &other ) const
    {
        if ( size() != other.size() )
        {
            return false;
        }

        for ( unsigned i = 0; i < size(); ++i )
        {
            if ( !other.exists( get( i ) ) )
            {
                return false;
            }
        }

        return true;
    }

    bool operator<( const EventVector &other ) const
    {
        if ( size() < other.size() )
        {
            return true;
        }

        if ( size() > other.size() )
        {
            return false;
        }

        unsigned eventType = 0;
        unsigned hits = 0;

        while ( hits < size() )
        {
            if ( exists( Event( eventType ) ) && !other.exists( Event( eventType ) ) )
            {
                return true;
            }

            if ( !exists( Event( eventType ) ) && other.exists( Event( eventType ) ) )
            {
                return false;
            }

            if ( exists( Event( eventType ) ) && other.exists( Event( eventType ) ) )
            {
                ++hits;
            }

            ++eventType;
        }

        return false;
    }

    void dump() const
    {
        for ( unsigned i = 0; i < size(); ++i )
        {
            printf( "%u ", get( i ).type() );
        }
    }
};

#endif // __EventVector_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
