#ifndef __ForkOne_h__
#define __ForkOne_h__

#include "BThread.h"
#include "IEvent.h"
#include "String.h"
#include "T/Truth.h"
#include <cstdio>

class ForkOne : public BThread
{
public:
    void entryPoint()
    {
        while ( T::alwaysTrue() )
        {
            waitForPickUp();

            printf( "\tFork #1 picked up\n" );
            fflush( 0 );

            waitForPutDown();

            printf( "\tFork #1 put down\n" );
            fflush( 0 );
        }
    }

private:
    void clearAll()
    {
        _requested.clear();
        _watched.clear();
        _blocked.clear();
    }

    Vector<Event> pickUpEvents()
    {
        Vector<Event> pickUps;

        pickUps.append( IEvent::PHIL_ONE_PICK_LEFT );
        pickUps.append( IEvent::PHIL_THREE_PICK_RIGHT );

        return pickUps;
    }

    Vector<Event> putDownEvents()
    {
        Vector<Event> putDowns;

        putDowns.append( IEvent::PHIL_ONE_PUT_LEFT );
        putDowns.append( IEvent::PHIL_THREE_PUT_RIGHT );

        return putDowns;
    }

    void waitForPickUp()
    {
        clearAll();
        _watched = pickUpEvents();
        _blocked = putDownEvents();
        bSync( _requested, _watched, _blocked, String( "#1Down" ) );
    }

    void waitForPutDown()
    {
        clearAll();
        _watched = putDownEvents();
        _blocked = pickUpEvents();
        bSync( _requested, _watched, _blocked, String( "#1Up" ) );
    }
};

#endif // __ForkOne_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
