#ifndef __IEvent_h__
#define __IEvent_h__

#include "Stringf.h"

class IEvent
{
public:
    enum EventType {
        PHIL_ONE_PICK_LEFT = 0,
        PHIL_ONE_PICK_RIGHT = 1,
        PHIL_ONE_PUT_LEFT = 2,
        PHIL_ONE_PUT_RIGHT = 3,

        PHIL_TWO_PICK_LEFT = 4,
        PHIL_TWO_PICK_RIGHT = 5,
        PHIL_TWO_PUT_LEFT = 6,
        PHIL_TWO_PUT_RIGHT = 7,

        PHIL_THREE_PICK_LEFT = 8,
        PHIL_THREE_PICK_RIGHT = 9,
        PHIL_THREE_PUT_LEFT = 10,
        PHIL_THREE_PUT_RIGHT = 11,

        NUMBER_OF_EVENTS = 12,
    };

    static Vector<Event> allEvents()
    {
        Vector<Event> result;

        for ( unsigned i = 0; i < NUMBER_OF_EVENTS; ++i )
        {
            result.append( Event( i ) );
        }

        return result;
    }

    static String philosopherEatingAP( unsigned philosopherIndex )
    {
        return Stringf( "Phil_#%u_Eating", philosopherIndex );
    }
};

#endif // __IEvent_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
