#include "BProgram.h"
#include "CustomizedOracle.h"
#include "ForkOne.h"
#include "ForkThree.h"
#include "ForkTwo.h"
#include "Oracle.h"
#include "PhilOne.h"
#include "PhilThree.h"
#include "PhilTwo.h"

int main()
{
    srand( time( NULL ) );

    try
    {
        BProgram bProgram;
        bProgram.runEngine();

        Oracle::setChooser( new CustomizedOracle );

        PhilOne philOne;
        PhilTwo philTwo;
        PhilThree philThree;

        ForkOne forkOne;
        ForkTwo forkTwo;
        ForkThree forkThree;

        bProgram.addThread( philOne );
        bProgram.addThread( philTwo );
        bProgram.addThread( philThree );

        bProgram.addThread( forkOne );
        bProgram.addThread( forkTwo );
        bProgram.addThread( forkThree );

        bProgram.runProgram();

        sleep( 100 );
    }
    catch ( const Error &e )
    {
        printf( "Main Thread: Error caught. Code: %u. Errno: %i\n", e.code(), e.errno() );
        fflush( 0 );
    }

	return 0;
}

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
