#ifndef __OneAndTwoDisjoint_h__
#define __OneAndTwoDisjoint_h__

#include "NFA.h"

class OneAndTwoDisjoint
{
public:
    static NFA getNfa()
    {
        NFA safetyProperty;

        safetyProperty.addLetter( "Phi" );
        safetyProperty.addLetter( "Phil#1Eating" );
        safetyProperty.addLetter( "Phil#2Eating" );
        safetyProperty.addLetter( "Phil#1Eating;Phil#2Eating" );

        safetyProperty.addState( "q0" );
        safetyProperty.addState( "q1" );

        safetyProperty.setInitialState( "q0" );
        safetyProperty.markAsAccepting( "q1" ); // This is the state we DONT want to reach

        safetyProperty.addEdge( NFA::Edge( "q0", "Phi", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "Phil#1Eating", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "Phil#2Eating", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "Phil#1Eating;Phil#2Eating", "q1" ) );

        safetyProperty.addEdge( NFA::Edge( "q1", "Phi", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "Phil#1Eating", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "Phil#2Eating", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "Phil#1Eating;Phil#2Eating", "q1" ) );

        return safetyProperty;
    }
};

#endif // __OneAndTwoDisjoint_h__

//
// Local Variables:
// compile-command: "make -C ../../.. "
// tags-file-name: "../../../TAGS"
// c-basic-offset: 4
// End:
//
