#ifndef __OneThriceInARow_h__
#define __OneThriceInARow_h__

#include "NFA.h"

class OneThriceInARow
{
public:
    static NFA getNfa()
    {
        NFA safetyProperty;

        safetyProperty.addLetter( "Phi" );
        safetyProperty.addLetter( "Phil#1Eating" );
        safetyProperty.addLetter( "Phil#2Eating" );
        safetyProperty.addLetter( "Phil#1Eating;Phil#2Eating" );

        safetyProperty.addState( "q0" );
        safetyProperty.addState( "q1" );
        safetyProperty.addState( "q2" );
        safetyProperty.addState( "q3" );

        safetyProperty.setInitialState( "q0" );
        safetyProperty.markAsAccepting( "q3" ); // This is the state we DONT want to reach

        safetyProperty.addEdge( NFA::Edge( "q0", "Phi", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "Phil#1Eating", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "Phil#2Eating", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "Phil#1Eating;Phil#2Eating", "q1" ) );

        safetyProperty.addEdge( NFA::Edge( "q1", "Phi", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "Phil#1Eating", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "Phil#2Eating", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "Phil#1Eating;Phil#2Eating", "q2" ) );

        safetyProperty.addEdge( NFA::Edge( "q2", "Phi", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "Phil#1Eating", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "Phil#2Eating", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "Phil#1Eating;Phil#2Eating", "q3" ) );

        safetyProperty.addEdge( NFA::Edge( "q3", "Phi", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "Phil#1Eating", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "Phil#2Eating", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "Phil#1Eating;Phil#2Eating", "q3" ) );

        return safetyProperty;
    }
};

#endif // __OneThriceInARow_h__

//
// Local Variables:
// compile-command: "make -C ../../.. "
// tags-file-name: "../../../TAGS"
// c-basic-offset: 4
// End:
//
